//Quickshot.cs

//audio
datablock AudioProfile(QuickshotShotSound)
{
   filename    = "base/data/sound/sprayloop.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(QuickshotreloadSound)
{
   filename    = "./QSreload.wav";
   description = AudioClose3d;
   preload = true;
};

//shell

//muzzle flash effects

datablock ParticleData(QuickshotTrailParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0.1 1 0.3";
	colors[1]     = "0 0 1 0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.35;

	useInvAlpha = true;
};


datablock ParticleEmitterData(QuickshotTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "QuickshotTrailParticle";

   uiName = "Quickshot Trail";
};





datablock ParticleData(QuickshotFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(QuickshotFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "QuickshotFlashParticle";

   uiName = "Quickshot Flash";
};

datablock ParticleData(QuickshotSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(QuickshotSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "QuickshotSmokeParticle";

   uiName = "Quickshot Smoke";
};


datablock ParticleData(QuickshotExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0.1 1 0.3";
	colors[1]     = "0 0 1 0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(QuickshotExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "QuickshotExplosionParticle";

   useEmitterColors = true;
   uiName = "Quickshot Hit Dust";
};


datablock ParticleData(QuickshotExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0.1 1 0.9";
	colors[1]     = "0 0.1 1 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(QuickshotExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "QuickshotExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Quickshot Hit Flash";
};

datablock ExplosionData(QuickshotExplosion)
{
   //explosionShape = "";
	soundProfile = QuickshotShotSound;

   lifeTimeMS = 150;

   particleEmitter = QuickshotExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = QuickshotExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


AddDamageType("Quickshot",   '<bitmap:add-ons/Weapon_Quickshot/CI_Quickshot> %1',    '%2 <bitmap:add-ons/Weapon_Quickshot/CI_Quickshot> %1',0.2,1);
datablock ProjectileData(QuickshotProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::Quickshot;
   radiusDamageType    = $DamageType::Quickshot;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = QuickshotExplosion;
   particleEmitter     = Quickshottrailemitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Quickshot Bullet";
};

//////////
// item //
//////////
datablock ItemData(QuickshotItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Quickshot.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Quickshot";
	iconName = "./icon_Quickshot";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = QuickshotImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(QuickshotImage)
{
   // Basic Item properties
   shapeFile = "./Quickshot.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = QuickshotProjectile;
   projectileType = Projectile;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = QuickshotItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= sprayActivateSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Ammo1";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

//reload passage!

	stateName[2]                     = "Reload";
	stateAllowImageChange[2]         = true;
	stateSequence[2]                = "Reload";
	stateScript[2]                  = "Reload";
	stateSequence[2]	= "Reload";
	stateTransitionOnTimeout[2]     = "Reload2";
	stateWaitForTimeout[2]			= true;
	stateTimeoutValue[2]				= 0.75;
	stateSound[2]					= QuickshotreloadSound;

	stateName[3]                     = "Reload2";
	stateAllowImageChange[3]         = true;
	stateSequence[3]                = "Reload2";
	stateScript[3]                  = "Reload2";
	stateSequence[3]	= "Reload2";
	stateTransitionOnTimeout[3]     = "Ready";
	stateWaitForTimeout[3]			= true;
	stateTimeoutValue[3]				= 0.85;

//ammo passage and firing
//first shot

	stateName[4]                    = "Ammo1";
	stateTransitionOnTimeout[4]     = "Ammo1Ready";
	stateTimeoutValue[4]            = 0.20;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateSound[4]					= QuickshotshotSound;

	stateName[5]                     = "Ammo1Ready";
	stateTransitionOnTriggerDown[5]  = "Ammo2";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "Ready";

//second shot

	stateName[6]                    = "Ammo2";
	stateTransitionOnTimeout[6]     = "Ammo2Ready";
	stateTimeoutValue[6]            = 0.20;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateSound[6]					= QuickshotshotSound;

	stateName[7]                     = "Ammo2Ready";
	stateTransitionOnTriggerDown[7]  = "Ammo3";
	stateAllowImageChange[7]         = true;
	stateSequence[7]	= "Ready";

//third shot

	stateName[8]                    = "Ammo3";
	stateTransitionOnTimeout[8]     = "Ammo3Ready";
	stateTimeoutValue[8]            = 0.20;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateSound[8]					= QuickshotshotSound;

	stateName[9]                     = "Ammo3Ready";
	stateTransitionOnTriggerDown[9]  = "Ammo4";
	stateAllowImageChange[9]         = true;
	stateSequence[9]	= "Ready";

//fourth shot

	stateName[10]                    = "Ammo4";
	stateTransitionOnTimeout[10]     = "Ammo4Ready";
	stateTimeoutValue[10]            = 0.20;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateSequence[10]                = "Fire";
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]			= true;
	stateSound[10]					= QuickshotshotSound;

	stateName[11]                     = "Ammo4Ready";
	stateTransitionOnTriggerDown[11]  = "Ammo5";
	stateAllowImageChange[11]         = true;
	stateSequence[11]	= "Ready";

//fifth shot

	stateName[12]                    = "Ammo5";
	stateTransitionOnTimeout[12]     = "Ammo5Ready";
	stateTimeoutValue[12]            = 0.20;
	stateFire[12]                    = true;
	stateAllowImageChange[12]        = false;
	stateSequence[12]                = "Fire";
	stateScript[12]                  = "onFire";
	stateWaitForTimeout[12]			= true;
	stateSound[12]					= QuickshotshotSound;

	stateName[13]                     = "Ammo5Ready";
	stateTransitionOnTriggerDown[13]  = "AmmoR";
	stateAllowImageChange[13]         = true;
	stateSequence[13]	= "Ready";

//Sixth shot and loop back to reload

	stateName[14]                    = "AmmoR";
	stateTransitionOnTimeout[14]     = "Reload";
	stateTimeoutValue[14]            = 0.14;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateSequence[14]                = "Fire";
	stateScript[14]                  = "onFire";
	stateWaitForTimeout[14]			= true;
	stateSound[14]					= QuickshotshotSound;
};
